var WriteCardSDK = function(mode) {
	var callMode_HTTP = "HTTP";//HTTP
	var callMode_SOCKET = "WebSocket";// WebSocket
	var transMode = "0";  //  0  明文方式  1 密文方式
	
	//检测操作系统
	var detectOS = function() {
		var sUserAgent = navigator.userAgent; 
		var isWin = (navigator.platform == "Win32") || (navigator.platform == "Windows"); 
		var isMac = (navigator.platform == "Mac68K") || (navigator.platform == "MacPPC") || (navigator.platform == "Macintosh") || (navigator.platform == "MacIntel"); 
		if (isMac) return "Mac"; 
			var isUnix = (navigator.platform == "X11") && !isWin && !isMac; 
		if (isUnix) return "Unix"; 
			var isLinux = (String(navigator.platform).indexOf("Linux") > -1); 
			var bIsAndroid = sUserAgent.toLowerCase().match(/android/i) == "android";
		if (isLinux) {
			if(bIsAndroid) 
				return "Android";
		else 
			return "Linux"; 
			}
		if (isWin) {
			return "isWin"; 
		}		
		return "other"; 
	};
	
	var Client = function(_data,_callback) {
		//微软系统，使用组件方式调用
		var os=detectOS();
		if("isWin"==os){
			var restr='';
			try {
				 restr = ocxClient(_data,_callback);
			} catch(err) {
				 restr = _callback(getResultMsg("-21", err.message));
			}
			
		}else if("Linux"==os){
			if(callMode_HTTP==mode){
				var restr='';
				try {
					 restr = httpClient(_data,_callback);
				} catch(err) {
					 restr = _callback(getResultMsg("-21", err.message));
				}
			}else if(callMode_SOCKET==mode){
				var restr='';
				try {
					 restr = socketClient(_data,_callback);
				} catch(err) {
					 restr = _callback(getResultMsg("-21", err.message));
				}
			}
			
		}else{
			var restr=_callback(getResultMsg("-21","暂不支持此种方式"));
		}
	};
	var ocxClient = function(_data,_callback) {
		//解析请求参数
		var obj = JSON.parse(_data); 
		var cmd=obj.function;
		var scncsdll = document.getElementById("scncsdll");
		//objocx.RspCardData=_callback;
		//var objocx = new ActiveXObject("OPSCLIENT.OpsClientCtrl.1");
		if(scncsdll){
		switch(cmd)
		{
		case 'getSdkVersion':
			 var result=scncsdll.Get_OPSVersion();
			 break;
		case 'getCardInfo' :
			var result=scncsdll.Get_CardInfo();
			break;
		case 'writeCardEn' :
			var str=obj.issueData;
			var result=scncsdll.Write_Card(1,str);
			break;
		case 'writeCardDe' :
			var str=obj.issueData;
			var result=scncsdll.Write_Card(0,str);
			break;
		case 'getCardSN' :
			var result=scncsdll.Get_IMSI();
			break;
		case 'getCardIMSI' :
			var result=scncsdll.Get_IMSI();
			break;
		case 'getCardICCID' :
			var result=scncsdll.Get_ICCID();
			break;
		default:
				var restr=_callback(getResultMsg("-23","接口暂未开放！"));
				break;
		}
		}else{
			var restr=_callback(getResultMsg("-22","未安装写卡控件或未设置受信任站点！"));
		}
	}
	
	var httpClient = function(_data, _callback) {	
		var http = null;
		var restr="";
		var url = "http://127.0.0.1:8389/OPS?data=";
		url += _data + "&timeStamp=" + new Date().getTime();
		http = new XMLHttpRequest();
		http.open("GET", url);
			if (http != null) {
			http.onload = function() {
				if (http.readyState == 4 && http.status == 200) {
						_callback(http.responseText);
					} else {
						_callback(getResultMsg("-1", "Request was unsuccessfull: status=" + http.status + ", readyState=" + http.readyState));
					}
			};
			http.onerror = function() {
				_callback(getResultMsg("-1", "Request was unsuccessfull," + http));
			};
			http.send(null);
		} else {
			_callback(getResultMsg("-1", "Your browser does not support CORS."));
		}	
	};
	
	var socketClient = function(_data,_callback) {
		//var ws = new WebSocket("ws://192.168.5.26:9000/");
		var ws = new WebSocket("ws://127.0.0.1:9000/");
		var restr="";
		//连接成功后回调
		ws.onopen = function (evt) {
			ws.send(_data);
		}
		//收到数据后回调
		ws.onmessage = function (event) {
			_callback(event.data);
			ws.close();
		}
		//关闭后回调
		ws.onclose = function (evt) {
			
		}
		ws.onerror = function (event) {
			_callback(getResultMsg("-1", "Request was unsuccessfull"));
		}
	}
	
	var getResultMsg = function(_code, _message) {
		var str = '{"code":"' + _code +'","message":"' + _message + '"}';
		return str;
	};
	
	//获取版本信息
	WriteCardSDK.prototype.getSdkVersion = function(_callback) {
		var data = '{"function":"getSdkVersion"}';
		var restr='';
		try {
			restr = Client(data,_callback);
		} catch(err) {
			restr = getResultMsg("-11", err.message);
		}
	};
	//获取卡片信息
	WriteCardSDK.prototype.getCardInfo = function(_callback) {
		var data = '{"function":"getCardInfo"}';
		var restr='';
		try {
			restr = Client(data,_callback);
		} catch(err) {
			restr = getResultMsg("-21", err.message);
		}
	};
	//实时写卡
	WriteCardSDK.prototype.writeCard = function(issueData,_callback) {
		var data ="";
		if(transMode=="0"){
			data = '{"function":"writeCardDe","issueData":"'+issueData+'"}';
		}else{
			data = '{"function":"writeCardEn","issueData":"'+issueData+'"}';
		}
		
		var restr='';
		try {
			restr =  Client(data,_callback);
		} catch(err) {
			restr =  getResultMsg("-21", err.message);
		}
	};
	//获取卡片ATR
	WriteCardSDK.prototype.getCardATR = function(_callback) {
		var data = '{"function":"getCardATR"}';
		var restr='';
		try {
			restr = Client(data,_callback);
		} catch(err) {
			restr =  getResultMsg("-21", err.message);
		}
	};
	//获取空卡序列号
	WriteCardSDK.prototype.getCardSN = function(_callback) {
		var data = '{"function":"getCardSN"}';
		var restr='';
		try {
			restr = Client(data,_callback);
		} catch(err) {
			restr =  getResultMsg("-21", err.message);
		}
	};
	//获取2F02
	WriteCardSDK.prototype.getCard2F02 = function(_callback) {
		var data = '{"function":"getCard2F02"}';
		var restr='';
		try {
			restr = Client(data,_callback);
		} catch(err) {
			restr =  getResultMsg("-21", err.message);
		}
	};
	//获取卡片IMSI
	WriteCardSDK.prototype.getCardIMSI = function(_callback) {
		var data = '{"function":"getCardIMSI"}';	
		var restr='';
		try {
			restr = Client(data,_callback);
		} catch(err) {
			restr = getResultMsg("-21", err.message);
		}
	};
	//获取卡片ICCID
	WriteCardSDK.prototype.getCardICCID = function(_callback) {
		var data = '{"function":"getCardICCID"}';
		var restr='';
		try {
			restr = Client(data,_callback);
		} catch(err) {
			restr = getResultMsg("-21", err.message);
		}
	};
	
};